// SMFR[hϊ

#pragma once

#include "Constants.h"
#include "Interface.h"
#include "SmfInterpreter.h"


namespace GuruGuruSmf { namespace Core { namespace Compiler {

	/// <summary>
	/// SMFCxgsp̊NX(Compiler)
	/// </summary>
	class SmfEventExecutor
	{
	public:
		// sI
		virtual void Execute(SmfEvent* smfEvent, ICompilerCore* core) = 0;
	};

	/// <summary>
	/// sȂp
	/// </summary>
	class NullEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core){}
	};
	
	/// <summary>
	/// e|p
	/// </summary>
	class TempoEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};
	
	/// <summary>
	/// m[gIp
	/// </summary>
	class NoteOnEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};
	
	/// <summary>
	/// m[gItp
	/// </summary>
	class NoteOffEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};
	
	/// <summary>
	/// vO`FWp
	/// </summary>
	class ProgramChangeEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};
	
	/// <summary>
	/// Rg[`FWp
	/// </summary>
	class ControlChangeEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};

	/// <summary>
	/// sb`xhp
	/// </summary>
	class PitchBendEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};

	/// <summary>
	/// `lvbV[p
	/// </summary>
	class CAfEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};
	
	/// <summary>
	/// |tHjbNL[vbV[p
	/// </summary>
	class PAfEventExecutor : public SmfEventExecutor
	{
	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
	};
	
	/// <summary>
	/// GNXN[Vup
	/// </summary>
	class ExclusiveEventExecutor : public SmfEventExecutor
	{
	private:
		// f[^r
		bool CompareExclusive(const byte* data, const byte* compare, int position, int length);

	public:
		void Execute(SmfEvent* smfEvent, ICompilerCore* core);
		
	};

	/// <summary>
	/// SMFϊ
	/// </summary>
	class Compiler : public SmfInterpreter, public ICompilerCore
	{
	private:
		GgsCode* code;
		SmfEventExecutor** eventExecutors;
		int markerTick;

	protected:
		// Ticki߂
		void UpdateTick(int newTick);
		
		// Cxg
		void EventExecute(SmfEvent* smfEvent);
		
		// 
		void Initialize(Smf* newSmf);
	
	public:
		Compiler();		// RXgN^
		~Compiler();	// fXgN^

		//
		// ICompilerCore
		//
		
		// GGSCodeIuWFNg
		GgsCode* GetCode(){ return code; }
		
		// 2oCg̃Cxg
		void Write2ByteEvent(CODE_EVENTTYPE type, SmfEvent* smfEvent);

		// GNXN[VuCxg
		void WriteExclusiveEvent(SmfEvent* smfEvent);
		
		// Yp[gCxg
		void WriteUseRhythmPartEvent(SmfEvent* smfEvent, int channel, bool rhythm);

		//

		// ϊI
		GGSERROR Compile(Smf* newSmf);
		
		
	};





}}}



