// GuruGuruSMF4̒萔

#pragma once

typedef unsigned char byte;
typedef unsigned int uint;

namespace GuruGuruSmf {

	namespace PlayOption
	{
		const int Loop = 1;			// [vĐ
		const int SkipBeginning = 2;	// `̋󔒂XLbv
		const int SkipEnding = 4;		// ̋󔒂XLbv
		const int MasterPitch = 8;		// }X^[sb`Lɂ
		const int Normalize = 16;		// ő剹ʂ127Ɉグ
		const int Exclusive = 32;		// GNXN[Vu𑗐M
	}
	
	namespace LoadOption
	{
		const int Buffered = 1;		// f[^ɕێ邩
	}
	
	namespace Device
	{
		const int DirectMusicPerformance = -1000;	// DirectMusic Performance[h(p~)
		const int DirectMusic = -1100;				// DirectMusic Port[h
	}
	
	/// <summary>
	/// G[R[h
	/// </summary>
	namespace GgsError {
		enum Code {
			NoError, 			// G[Ȃ
			Failed,				// Ȃ񂾂悭킩Ȃǎs
			FileNotFound,		// t@C݂Ȃ
			CannotOpenFile,		// t@CJȂ
			FileLoadFailed,		// t@Cǂݍ݂Ɏs
			BadFileSize,		// t@CTCYs
			NoSmf,				// SMFł͂܂
			BadSmf,				// sSMF
			UnmatchedSmf,		// ΉSMF
			CannotOpenDevice,	// foCXJȂ
			CannotStartTimer,	// ^C}[JnłȂ
			IllegalPointer,		// ͈͊OQƂ悤Ƃ
			TrackLimit,			// bZ[W̓rŃgbNI[ɒB
			NotReady,			// t\ł͂Ȃ
			UndefinedId,		// `ID
			ApiNull				// APILłȂ
		};
	}
	typedef GgsError::Code GGSERROR;
	

	/// <summary>
	/// vC[̏
	/// </summary>
	namespace PlayerState {
		enum Code {
			Stop,		// ~
			Play,		// t
			Pause,		// ꎞ~
			Suspended	// TXyhɂfoCXĂ܂
		};
	}
	typedef PlayerState::Code PLAYERSTATE;

	/// <summary>
	/// vC[̏
	/// </summary>
	struct PlayerStatus
	{
		PLAYERSTATE State;
		int Tempo;
		int Tick;
		int Time;
		int LoopCount;
	};

	/// <summary>
	/// PerformancePlay֓nSMFf[^
	/// </summary>
	struct PerformancePlaySmfData
	{
		int StoredType;
		const wchar_t* FileName;
		void* SmfBinary;
		int SmfBinaryLength;
		int TimeBase;
		int TotalTick;
		int FirstNoteTick;
		int LastNoteTick;
		int LoopTick;
	};

	/// <summary>
	/// SMF̃f[^
	/// </summary>
	struct SmfInformation
	{
		int TimeBase;		// x[XJEg
		int TotalTick;		// Tick
		int TotalTime;		// t
		int FirstNoteTick;	// ŏ̔tick
		int FirstNoteTime;	// ŏ̔̎
		int LastNoteTick;	// Ō̔tick
		int LastNoteTime;	// Ō̔̎
		int LoopTick;		// CC#111̈ʒu
		int LoopTime;		// CC#111̈ʒu̎
	};

	/// <summary>
	/// SMFXg̃L[ꗗ
	/// </summary>
	struct SmfListKeys
	{
		int Count;		// L[̐
		int* Keys;		// L[̃Xg
	};

}


namespace GuruGuruSmf { namespace Core
{
	
	/// <summary>
	/// gbN̏
	/// </summary>
	namespace TrackState {
		enum Code {
			Play,		// t()
			End			// I
		};
	}
	typedef TrackState::Code TRACKSTATE;

	/// <summary>
	/// f[^̕ۑ^Cv
	/// </summary>
	namespace StoredType {
		enum Code {
			File, Memory
		};
	}
	typedef StoredType::Code STOREDTYPE;
	
	/// <summary>
	/// SMFCxg萔
	/// </summary>
	namespace SmfEventType {
		enum Code {
			NoteOff, NoteOn, ProgramChange, ControlChange,
			PitchBend, CAf, PAf,
			MetaEvent, Tempo, Exclusive,
			TrackEnd
		};
	}

	typedef SmfEventType::Code SMF_EVENTTYPE;
	
	// GNXN[VubZ[W
	namespace Exclusive
	{
		// GMVXeI
		const int GMSystemOnLength = 6;
		const byte GMSystemOn[6] = {0xf0,0x7e,0x7f,0x09,0x01,0xf7};
		
		// GSZbg
		const int GSResetLength = 11;
		const byte GSReset[11] = {0xf0,0x41,0x10,0x42,0x12,0x40,0x00,0x7f,0x00,0x41,0xf7};
	}
	
	// [v^Cv
	namespace LoopType {
		enum Code {
			Beginning,				// ŏ([v|CgȂ)
			LoopPointAtBeginning,	// [v|Cgōŏ
			LoopPoint,				// [v|Cg
			End						// I
		};
	}

	typedef LoopType::Code LOOPTYPE;
	
	// GGSCodẽCxg^Cv
	namespace CodeEventType {
		enum Code {
			DeltaTime, NoteOn, NoteOff,
			ProgramChange, ControlChangeA, ControlChangeB, ControlChangeC, Volume,
			PAf, CAf, PitchBend,
			Tempo, Exclusive, UseRhythmPart,
			MusicEnd
		};
	}

	typedef CodeEventType::Code CODE_EVENTTYPE;
	
	// {[Rg[̏
	namespace VolumeState {
		enum Code {
			Normal, FadeIn, FadeOut
		};
	}

	typedef VolumeState::Code VOLUMESTATE;
	
	
	// ̑萔
	namespace Constant {
		const int MaxTick = 0x70000000;		// Tick̍ől(Ƃ肠̐)
		const __int64 PrepareTime = 600000;		// Port[hŐ揈鎞(60ms)
		const int TimeInterval = 5;			// 񓯊(5ms)
		const double DefaultTempo = 500000;			// e|̏l(500000 = bpm120)
		const int GSChannel[] = {9,0,1,2,3,4,5,6,7,8,10,11,12,13,14,15};	// GSchz
	}


}}





