
#include "stdafx.h"

#include "Ggs4Controller.h"

namespace GuruGuruSmf { namespace Core {

	//
	// GgsController
	//

	// TXyh֘Au
	int _deviceId = -1100;	// ŌɊJfoCXID
	HWND _handle = NULL;	// ̎̃nh
	bool _isSuspended = false;	// TXyh㖢
	bool _isDeviceOpen = false;	// TXyhɃfoCXJĂǂ
	DWORD _openedTime;		// ŌɃfoCXJ(ʏ펞gp)
	PlayerStatus _suspendedStatus;	// TXyh̉t

	// TXyh
	void _Suspend(GgsController* ggs)
	{
		if (_isDeviceOpen){
			ggs->GetPlayerStatus(&_suspendedStatus, sizeof(PlayerStatus));
			if (_suspendedStatus.State == PlayerState::Play || _suspendedStatus.State == PlayerState::Pause){
				_suspendedStatus.State = PlayerState::Suspended;
			}
			_isSuspended = true;
			ggs->CloseDevice();
		}
	}

	// TXyh(GGS4)
	void Ggs4Suspend()
	{
		Ggs4Controller* ggs = Ggs4Controller::GetInstance();
		_Suspend(ggs);
	}
	// TXyh(GGS3)
	void Ggs3Suspend()
	{
		Ggs3Controller* ggs = Ggs3Controller::GetInstance();
		_Suspend(ggs);
	}

	// RXgN^
	GgsController::GgsController()
	{
		playingId = 0;
		nextId = 1;
		listKeys = 0;

		smfPlayer = 0;
		analyzer = new Analyzer::Analyzer();
		compiler = new Compiler::Compiler();

		winHidden = new PowerControlWindow();
	}

	// fXgN^
	GgsController::~GgsController()
	{
		CloseDevice();
		delete winHidden;

		ClearList();
		delete[] listKeys;

		delete smfPlayer;

		delete analyzer;
		delete compiler;
		GuruGuruSmf::Dxmus::Controller::FreeInstance();

	}

	// foCXJ
	GGSERROR GgsController::OpenDevice(int deviceId, HWND handle)
	{
		_isSuspended = false;
		CloseDevice();

		_openedTime = GetTickCount();
		smfPlayer = MakePlayer(deviceId);
		
		GGSERROR err = smfPlayer->OpenDevice(deviceId, handle);
		if(err != GgsError::NoError){
			delete smfPlayer;
			smfPlayer = 0;
			return err;
		}

		_deviceId = deviceId;
		_handle = handle;
		_isDeviceOpen = true;
		return GgsError::NoError;
	}
		
	// foCX
	void GgsController::CloseDevice()
	{
		_isDeviceOpen = false;
		TRACE(L"Ggs4Controller::CloseDevice\n");
		Stop(0);
		if(smfPlayer){
			TRACE(L": smfPlayer->CloseDevice()\n");
			smfPlayer->CloseDevice();

			delete smfPlayer;
			smfPlayer = 0;
			TRACE(L": CloseDevice: done\n");
		}
	}


	// XgNA
	void GgsController::ClearList()
	{
		Stop(0);

		std::map<int, SmfController*>::iterator it = smfList.begin();
		
		while(it != smfList.end()){
			delete (*it).second;
			++it;
		}
		smfList.clear();
	}

	// Xg̃ACe1폜
	void GgsController::DeleteListItem(int musicId)
	{
		// tSMF폜悤Ƃ牉t~
		if(playingId == musicId) Stop(0);

		std::map<int, SmfController*>::iterator it = smfList.find(musicId);
		if(it != smfList.end()){
			delete (*it).second;
			smfList.erase(musicId);
		}
	}

	// XgID
	const SmfListKeys* GgsController::EnumList()
	{
		int size = smfList.size();
		smfListKeys.Count = size;

		delete[] listKeys;
		listKeys = 0;
		if(size == 0){
			smfListKeys.Keys = 0;
			return &smfListKeys;
		}

		listKeys = new int[size];
		int i = 0;
		std::map<int, SmfController*>::iterator it = smfList.begin();

		while(it != smfList.end()){
			listKeys[i++] = (*it).first;
			++it;
		}
		smfListKeys.Keys = listKeys;

		return &smfListKeys;
	}

	// XgID񋓂ĕ(Legacy)
	const char* GgsController::EnumListToString()
	{
		char buf[16];
		EnumList();
		listKeysString.clear();

		int count = smfListKeys.Count;
		if(count){
			sprintf_s(buf, 16, "%d", listKeys[0]);
			listKeysString += buf;
			for(int i=1; i<count; i++){
				sprintf_s(buf, 16, ",%d", listKeys[i]);
				listKeysString += buf;
			}
		}

		return listKeysString.c_str();
	}

	// t@C烊Xg֒ǉ(ver.0.3.3)
	GGSERROR GgsController::AddListFromFile3(LPCSTR fileName, int option, int musicId)
	{
		if(musicId == 0){
			musicId = nextId++;
		}
		return AddListFromFileA(fileName, option, musicId);
	}

	// t@C烊Xg֒ǉ(ANSI)
	GGSERROR GgsController::AddListFromFileA(LPCSTR fileName, int option, int musicId)
	{
		int len = MultiByteToWideChar(CP_ACP, 0, fileName, -1, NULL, 0);
		wchar_t* stringBuff = new wchar_t[len];
		MultiByteToWideChar(CP_ACP, 0, fileName, -1, stringBuff, len);

		GGSERROR err = AddListFromFileW(stringBuff, option, musicId);
		delete[] stringBuff;

		return err;
	}

	// t@C烊Xg֒ǉ(UNICODE)
	GGSERROR GgsController::AddListFromFileW(LPCWSTR fileName, int option, int musicId)
	{
		DeleteListItem(musicId);
		
		SmfController* smfController = MakeSmfController((option & LoadOption::Buffered) != 0);
		smfController->Initialize(analyzer, compiler);

		GGSERROR err = smfController->LoadFromFile(fileName);
		if(err != GgsError::NoError) return err;
		smfList[musicId] = smfController;
		
		return GgsError::NoError;
	}

	// 烊Xg֒ǉ(ver.0.3.3)
	GGSERROR GgsController::AddListFromMemory3(const byte* smfBinary, int length, int option, int musicId)
	{
		if(musicId == 0){
			musicId = nextId++;
		}
		return AddListFromMemory(smfBinary, length, option, musicId);
	}

	// 烊Xg֒ǉ
	GGSERROR GgsController::AddListFromMemory(const byte* smfBinary, int length, int option, int musicId)
	{
		
		// tSMF㏑悤Ƃ牉t~
		if(playingId == musicId) Stop(0);
		
		DeleteListItem(musicId);
		
		SmfController* smfController = MakeSmfController((option & LoadOption::Buffered) != 0);
		smfController->Initialize(analyzer, compiler);

		GGSERROR err = smfController->LoadFromMemory(smfBinary, length);
		if(err != GgsError::NoError) return err;
		smfList[musicId] = smfController;

		return GgsError::NoError;
	}

	// ~I
	void GgsController::Stop(int fadeOutTime)
	{
		if(fadeOutTime < 100){
			fadeOutTime = 0;
		}
		
		if(smfPlayer){
			smfPlayer->Stop(fadeOutTime);
		}
	}

	// tI
	GGSERROR GgsController::Play(int option, int musicId, int seek, int fadeInTime, int keyShift)
	{
		GGSERROR err;
		if(_isSuspended){
			_isSuspended = false;
			err = OpenDevice(_deviceId, _handle);
			if (err != GgsError::NoError) return err;
		}

		if(smfPlayer == 0) return GgsError::NotReady;
		
		Stop(0);
		if(smfList.find(musicId) == smfList.end()){
			return GgsError::UndefinedId;
		}
		
		SmfController* smfController = smfList[musicId];
		
		if(fadeInTime < 100){
			fadeInTime = 0;
		}

		// ŌɃfoCXJԂ1bȍ~ɂȂ悤ɂ
		DWORD now = GetTickCount();
		if (now < _openedTime + 1000)
		{
			DWORD wait = 1000 + _openedTime - now;
			if (wait > 1000) wait = 1000;	// ȐlɂȂĂ1000ɂ
			Sleep(wait);
		}
		
		err = smfPlayer->Play(smfController, option, seek, fadeInTime, keyShift);
		if(err != GgsError::NoError)	return err;
		playingId = musicId;
		
		return GgsError::NoError;
	}

	// DLSǉ(ANSI)
	GGSERROR GgsController::AddDlsA(LPCSTR fileName)
	{
		int len = MultiByteToWideChar(CP_ACP, 0, fileName, -1, NULL, 0);
		wchar_t* stringBuff = new wchar_t[len];
		MultiByteToWideChar(CP_ACP, 0, fileName, -1, stringBuff, len);

		GGSERROR err = AddDlsW(stringBuff);
		delete[] stringBuff;

		return err;
	}

	// DLSǉ(UNICODE)
	GGSERROR GgsController::AddDlsW(LPCWSTR fileName)
	{
		GGSERROR err = GuruGuruSmf::Dxmus::Controller::GetInstance()->PortAddDls((wchar_t*)fileName);
		if(err) return err;
		return GgsError::NoError;
	}

	// ꎞ~
	void GgsController::Pause()
	{
		if(smfPlayer){
			smfPlayer->Pause();
		}
	}
	
	// ꎞ~
	void GgsController::Restart()
	{
		if(smfPlayer){
			smfPlayer->Restart();
		}
	}

	// ꎞ~/(Legacy)
	void GgsController::PauseRestart()
	{
		if(smfPlayer){
			PlayerStatus status;
			smfPlayer->GetStatus(&status);
			switch(status.State){
			case PlayerState::Play:
				Pause();
				break;
			case PlayerState::Pause:
				Restart();
				break;
			}
		}
	}

		
	// SMF̏擾
	GGSERROR GgsController::GetSmfInformation(SmfInformation* info, int size, int musicId)
	{
		if(smfList.find(musicId) == smfList.end()) return GgsError::UndefinedId;
		
		Smf* smf = smfList[musicId]->GetSmf();
		if(!smf->GetIsReady()) return GgsError::NotReady;
		if(size < 4) return GgsError::NoError;
		info->TimeBase = smf->GetTimeBase();
		if(size < 8) return GgsError::NoError;
		info->TotalTick = smf->GetData()->TotalTick;
		if(size < 12) return GgsError::NoError;
		info->TotalTime = (int)smf->GetData()->TotalTime;
		if(size < 16) return GgsError::NoError;
		info->FirstNoteTick = smf->GetData()->FirstNoteTick;
		if(size < 20) return GgsError::NoError;
		info->FirstNoteTime = (int)smf->GetData()->FirstNoteTime;
		if(size < 24) return GgsError::NoError;
		info->LastNoteTick = smf->GetData()->LastNoteTick;
		if(size < 28) return GgsError::NoError;
		info->LastNoteTime = (int)smf->GetData()->LastNoteTime;
		if(size < 32) return GgsError::NoError;
		info->LoopTick = smf->GetData()->LoopTick;
		if(size < 36) return GgsError::NoError;
		info->LoopTime = (int)smf->GetData()->LoopTime;
		return GgsError::NoError;
	}

	// SMF̏擾(Legacy)
	GGSERROR GgsController::GetSmfInformation3(SmfInformation3* info, int musicId)
	{
		int size = info->Size;
		if(smfList.find(musicId) == smfList.end()) return GgsError::UndefinedId;
		
		Smf* smf = smfList[musicId]->GetSmf();
		if(!smf->GetIsReady()) return GgsError::NotReady;
		if(size < 8) return GgsError::NoError;
		info->TimeBase = smf->GetTimeBase();
		if(size < 12) return GgsError::NoError;
		info->TotalTick = smf->GetData()->TotalTick;
		if(size < 16) return GgsError::NoError;
		info->TotalTime = (int)smf->GetData()->TotalTime;
		if(size < 20) return GgsError::NoError;
		info->FirstNoteTick = smf->GetData()->FirstNoteTick;
		if(size < 24) return GgsError::NoError;
		info->LastNoteTick = smf->GetData()->LastNoteTick;
		if(size < 28) return GgsError::NoError;
		int loop = smf->GetData()->LoopTick;
		if(loop == -1) loop = 0;
		info->LoopTick = loop;

		return GgsError::NoError;
	}


	// tԂ擾
	void GgsController::GetPlayerStatus(PlayerStatus* status, int size)
	{
		PlayerStatus innerStatus;
		ZeroMemory(&innerStatus, sizeof(PlayerStatus));
		if (size < 4) return;
		if(_isSuspended){
			innerStatus = _suspendedStatus;
		}else{
			if(smfPlayer){
				smfPlayer->GetStatus(&innerStatus);
			}else{
				innerStatus.State = PlayerState::Stop;
			}
		}

		status->State = innerStatus.State;
		if(size < 8) return;
		status->Tempo = innerStatus.Tempo;
		if(size < 12) return;
		status->Tick = innerStatus.Tick;
		if(size < 16) return;
		status->Time = innerStatus.Time;
		if(size < 20) return;
		status->LoopCount = innerStatus.LoopCount;
	}

	// tԂ擾(Legacy)
	void GgsController::GetPlayerStatus3(PlayerStatus3* status)
	{
		PlayerStatus innerStatus;
		ZeroMemory(&innerStatus, sizeof(PlayerStatus));
		if (smfPlayer){
			smfPlayer->GetStatus(&innerStatus);
		}else{
			innerStatus.State = PlayerState::Stop;
		}

		int size = status->Size;

		if(size < 8) return;
		status->State = innerStatus.State;
		if(size < 12) return;
		status->Tempo = innerStatus.Tempo;
		if(size < 16) return;
		status->Tick = innerStatus.Tick;
		if(size < 20) return;
		status->Time = innerStatus.Time;
		if(size < 24) return;
		status->LoopCount = innerStatus.LoopCount;
	}

	// }X^[e|
	void GgsController::SetMasterTempo(float tempo)
	{
		if(smfPlayer){
			if(tempo < 0.1){
				tempo = (float)0.1;
			}else if(tempo > 8){
				tempo = 8;
			}
			smfPlayer->SetMasterTempo(tempo);
		}
	}
	
	// }X^[{[
	void GgsController::SetMasterVolume(int volume)
	{
		if(smfPlayer){
			smfPlayer->SetMasterVolume(volume);
		}
	}
	
	// }X^[sb`
	void GgsController::SetMasterPitch(int pitch)
	{
		if(smfPlayer){
			if(pitch < -8192){
				pitch = -8192;
			}else if(pitch > 8191){
				pitch = 8191;
			}
			smfPlayer->SetMasterPitch(pitch);
		}
	}


	//
	// Ggs4Controller
	//

	Ggs4Controller* Ggs4Controller::instance = 0;	// CX^Xu

	// 
	void Ggs4Controller::Initialize()
	{
		PowerControlWindow::SetCallBackSuspend(Ggs4Suspend);
	}

	// CX^X擾
	Ggs4Controller* Ggs4Controller::GetInstance()
	{
		if(instance == 0){
			instance = new Ggs4Controller();
		}
		return instance;
	}

	// CX^Xj
	void Ggs4Controller::FreeInstance()
	{
		delete instance;
		instance = 0;
	}

	// vC[IuWFNg쐬(Factory)
	IPlayer* Ggs4Controller::MakePlayer(int deviceId)
	{
		IPlayer* playerObject;
		switch(deviceId){
		case Device::DirectMusic:
		case Device::DirectMusicPerformance:
			playerObject = new DirectMusicPort::Player();
			break;
		default:
			playerObject = new WindowsMultimedia::Player();
			break;
		}
		return playerObject;
	}

	// SMFRg[[쐬(Factory)
	SmfController* Ggs4Controller::MakeSmfController(bool buffered)
	{
		SmfController* smfController;
		if(buffered){
			smfController = new SmfController4Buffered();
		}else{
			smfController = new SmfController4NotBuffered();
		}
		return smfController;
	}
	
	// }X^[{[
	void Ggs4Controller::SetMasterVolume(int volume)
	{
		if(volume > 0) volume = 0;
		if(volume < -127) volume = -127;

		GgsController::SetMasterVolume(volume);

	}

	//
	// Ggs3Controller
	//

	Ggs3Controller* Ggs3Controller::instance = 0;	// CX^Xu


	// 
	void Ggs3Controller::Initialize()
	{
		PowerControlWindow::SetCallBackSuspend(Ggs3Suspend);
	}

	// CX^X擾
	Ggs3Controller* Ggs3Controller::GetInstance()
	{
		if(instance == 0){
			instance = new Ggs3Controller();
		}
		return instance;
	}

	// CX^Xj
	void Ggs3Controller::FreeInstance()
	{
		delete instance;
		instance = 0;
	}

	// vC[IuWFNg쐬(Factory)
	IPlayer* Ggs3Controller::MakePlayer(int deviceId)
	{
		isPerformanceMode = false;
		IPlayer* playerObject;
		switch(deviceId){
		case Device::DirectMusic:
			playerObject = new DirectMusicPort::Player();
			break;
		case Device::DirectMusicPerformance:
			playerObject = new DirectMusicPerformance::Player();
			isPerformanceMode = true;
			break;
		default:
			playerObject = new WindowsMultimedia::Player();
			break;
		}
		return playerObject;
	}

	// SMFRg[[쐬(Factory)
	SmfController* Ggs3Controller::MakeSmfController(bool buffered)
	{
		SmfController* smfController;
		if(buffered){
			smfController = new SmfController3Buffered();
		}else{
			smfController = new SmfController3NotBuffered();
		}
		return smfController;
	}

	// }X^[{[
	void Ggs3Controller::SetMasterVolume(int volume)
	{
		if(!isPerformanceMode){
			if(volume > 0) volume = 0;
			if(volume < -127) volume = -127;
		}

		GgsController::SetMasterVolume(volume);

	}



}}

