// GuruGuruSMF4̑

#pragma once

#include <Windows.h>
#include <map>

#include "Constants.h"
#include "Smf.h"
#include "Analyzer.h"
#include "Compiler.h"
#include "WinmmPlayer.h"
#include "DmPortPlayer.h"
#include "DmPerformancePlayer.h"
#include "PowerControlWindow.h"

namespace GuruGuruSmf { namespace Core {

	// SMF̓f[^\(ver.0.3.3)
	struct SmfInformation3{
		int Size;			//̍\̂̃TCY
		int TimeBase;		//x[XJEg
		int TotalTick;		//Tick
		int TotalTime;		//t
		int FirstNoteTick;	//ŏ̔tick
		int LastNoteTick;	//Ō̔tick
		int LoopTick;		//CC#111̈ʒu
	};

	// tf[^\(ver.0.3.3)
	struct PlayerStatus3{
		int Size;		//̍\̂̃TCY
		int State;		//tǂ
		int Tempo;		//݂̃e|
		int Tick;		//݂̃eBbN
		int Time;		//݂̉t
		int LoopCount;	//݂̃[v
	};

	// Rg[NX
	class GgsController
	{
	private:
		std::map<int, SmfController*> smfList;
		SmfListKeys smfListKeys;
		int* listKeys;
		std::string listKeysString;
		Analyzer::Analyzer* analyzer;
		Compiler::Compiler* compiler;
		IPlayer* smfPlayer;
		int playingId;
		int nextId;

		PowerControlWindow* winHidden;

	protected:
		GgsController();		// RXgN^
		virtual ~GgsController();		// fXgN^

		// SMFRg[[쐬(Factory)
		virtual SmfController* MakeSmfController(bool buffered) = 0;

		// vC[IuWFNg쐬(Factory)
		virtual IPlayer* MakePlayer(int deviceId) = 0;

	public:
		// foCXJ
		GGSERROR OpenDevice(int deviceId, HWND handle);
		
		// foCX
		void CloseDevice();

		// DLSǉ
		GGSERROR AddDlsA(LPCSTR fileName);
		GGSERROR AddDlsW(LPCWSTR fileName);
		
		// t@C烊Xg֒ǉ
		GGSERROR AddListFromFileA(LPCSTR fileName, int option, int musicId);
		GGSERROR AddListFromFileW(LPCWSTR fileName, int option, int musicId);
		GGSERROR AddListFromFile3(LPCSTR fileName, int option, int musicId);
		
		// 烊Xg֒ǉ
		GGSERROR AddListFromMemory(const byte* smfBinary, int length, int option, int musicId);
		GGSERROR AddListFromMemory3(const byte* smfBinary, int length, int option, int musicId);

		// Xg̃ACe1폜
		void DeleteListItem(int musicId);
		
		// XgNA
		void ClearList();
		
		// XgID
		const SmfListKeys* EnumList();

		// XgID񋓂ĕ(Legacy)
		const char* EnumListToString();

		// tI
		GGSERROR Play(int option, int musicId, int seek, int fadeInTime, int keyShift);
		
		// ~I
		void Stop(int fadeOutTime);
		
		// ꎞ~
		void Pause();
		
		// ꎞ~
		void Restart();
		
		// ꎞ~/(Legacy)
		void PauseRestart();

		// SMF̏擾
		GGSERROR GetSmfInformation(SmfInformation* info, int size, int musicId);

		// SMF̏擾(Legacy)
		GGSERROR GetSmfInformation3(SmfInformation3* info, int musicId);
		
		// tԂ擾
		void GetPlayerStatus(PlayerStatus* status, int size);

		// tԂ擾(Legacy)
		void GetPlayerStatus3(PlayerStatus3* status);
		
		// }X^[e|
		void SetMasterTempo(float tempo);
		
		// }X^[{[
		virtual void SetMasterVolume(int volume);
		
		// }X^[sb`
		void SetMasterPitch(int pitch);

	};



	// Rg[(GuruGuruSMF4)
	class Ggs4Controller : public GgsController
	{
	private:
		static Ggs4Controller* instance;	// CX^Xu
		Ggs4Controller(){}		// RXgN^
		~Ggs4Controller(){}		// fXgN^

	protected:
		// SMFRg[[쐬(Factory)
		SmfController* MakeSmfController(bool buffered);

		// vC[IuWFNg쐬(Factory)
		IPlayer* MakePlayer(int deviceId);

	public:
		// 
		static void Initialize();

		// CX^X擾(singleton)
		static Ggs4Controller* GetInstance();

		// CX^Xj
		static void FreeInstance();

		// }X^[{[
		void SetMasterVolume(int volume);
	};
	
	// Rg[(GuruGuruSMF3)
	class Ggs3Controller : public GgsController
	{
	private:
		static Ggs3Controller* instance;	// CX^Xu
		bool isPerformanceMode;

		Ggs3Controller(){}		// RXgN^
		~Ggs3Controller(){}		// fXgN^

	protected:
		// SMFRg[[쐬(Factory)
		SmfController* MakeSmfController(bool buffered);

		// vC[IuWFNg쐬(Factory)
		IPlayer* MakePlayer(int deviceId);

	public:
		// 
		static void Initialize();

		// CX^X擾(singleton)
		static Ggs3Controller* GetInstance();

		// CX^Xj
		static void FreeInstance();

		// }X^[{[
		void SetMasterVolume(int volume);
	};
		
}}


