// SMFf[^֘A

#pragma once

#include <Windows.h>
#include <string>
#include <vector>
#include <set>

#include "Constants.h"

namespace GuruGuruSmf { namespace Core {

	/// <summary>
	/// FXg
	/// </summary>
	class VoiceList
	{
	private:
		int count;
		uint* items;

	public:
		VoiceList();	// RXgN^
		~VoiceList();	// fXgN^
		
		// setz񂩂Rs[
		void CopyFrom(std::set<uint>* src);

		// vf擾
		int GetCount(){ return count; }

		// vf擾
		uint* GetItems(){ return items; }
	};



	/// <summary>
	/// SMF̉̓f[^
	/// </summary>
	struct SmfAnalyzedData
	{
		int TotalTick;
		int TotalTime;
		int FirstNoteTick;
		double FirstNoteTime;
		int LastNoteTick;
		double LastNoteTime;
		int LoopTick;
		double LoopTime;
		int MaxVolume;
		int EventCount;
		VoiceList* VoiceList;
		LOOPTYPE LoopType;
	};


	/// <summary>
	/// GNXN[VubZ[W1(0xF0Ŏn܂̐p)
	/// </summary>
	class ExclusiveData
	{
	private:
		byte* binary;
		int length;

	public:
		ExclusiveData(byte* data, int len);	// RXgN^
		~ExclusiveData();	// fXgN^

		byte* GetData(){ return binary; }
		int GetLength(){ return length; }
	};


	// GgsCodẽCxg1(8oCgŒ)
	struct CodeEvent
	{
		union
		{
			int Header;
			struct
			{
				unsigned char Type;
				unsigned char Channel;
				unsigned char Option1;
				unsigned char Option2;
			};
		};

		union
		{
			int IntData;
			struct
			{
				unsigned char ByteData1;
				unsigned char ByteData2;
				unsigned char ByteData3;
				unsigned char ByteData4;
			};
		};
	};

	/// <summary>
	/// GuruGuruSMFR[h
	/// </summary>
	class GgsCode
	{
	private:
		std::vector<ExclusiveData*> exclusiveList;
		int length, position;
		int* binary;

	public:
		GgsCode();	// RXgN^
		~GgsCode();	// fXgN^

		// 
		int GetLength(){ return length; }
		
		// ݂̈ʒu(m[`FbN)
		int GetPosition(){ return position; }
		void SetPosition(int pos){ position = pos; }
		
		// ݒ
		void SetLength(int newLength);
		
		// ݂̈ʒuɃCxg
		void WriteEvent(CodeEvent* ev);
		
		// ݈ʒuCxgǂݍ
		void ReadEvent(CodeEvent* ev);

		// 0ɂăGNXN[Vuf[^J
		void Clear();
		
		// GNXN[Vuf[^o^ID擾
		int ResisterExclusive(ExclusiveData* exclusive);
		
		// GNXN[Vuf[^擾
		ExclusiveData* GetExclusive(int index);
	};

	/// <summary>
	/// SMF̃Cxg1
	/// </summary>
	struct SmfEvent
	{
		SMF_EVENTTYPE Type;		// Cxg
		int MidiStatus;			// MIDIXe[^X
		int DeltaTime;			// f^^C
		int Data1;				// f[^1
		int Data2;				// f[^2
		int EndPosition;		// gbN̏I[(Cxg擾Ɏgp)
		int ExclusiveLength;	// GNXN[Vu̒
		byte* ExclusiveData;	// GNXN[Vuf[^
	};


	/// <summary>
	/// SMF̃oCif[^
	/// </summary>
	class SmfStream
	{
	private:
		union Int32BE
		{
			int Value;
			byte B[4];
		};

		int position, length;
		byte* binary;
		const byte* baseAddress;
		bool isAllocate;

		// ϒ̐lǂݍ
		GGSERROR ReadVInt(int& intData, int endPosition);

		// 2oCgf[^̃Cxg擾
		GGSERROR ReadEvent2Data(SmfEvent* smfEvent, SMF_EVENTTYPE type);

		// 1oCgf[^̃Cxg擾
		GGSERROR ReadEvent1Data(SmfEvent* smfEvent, SMF_EVENTTYPE type);

		// sb`xhCxg擾
		GGSERROR ReadPitchBend(SmfEvent* smfEvent);

		// GNXN[VuCxg擾(0xf0) 0xf7n܂͖̂
		GGSERROR ReadExclusive(SmfEvent* smfEvent, int status);

		// ^Cxg擾
		GGSERROR ReadMetaEvent(SmfEvent* smfEvent);

	public:
		SmfStream();	// RXgN^
		~SmfStream();	// fXgN^

		// ݂̈ʒu
		int GetPosition(){ return position; }

		// f[^̃|C^擾
		const byte* GetBaseAddress(){ return baseAddress; }

		// 
		int GetLength(){ return length; }

		// t@Cǂݍ
		GGSERROR LoadFromFile(LPCWSTR fileName);

		// ǂݍ
		GGSERROR LoadFromMemory(const byte* smfBinary, int newLength);

		// j
		void Unload();

		// V[N
		GGSERROR Seek(int pos);

		// ݈ʒu2oCg̐l擾
		GGSERROR ReadUShort(int& intData);

		// ݈ʒu4oCg̐l擾
		GGSERROR ReadInt(int& intData);

		// ݈ʒuf^^C擾
		GGSERROR ReadDeltaTime(int& deltaTime, int endPosition);

		// ݈ʒuSMFCxg1{f^^C擾
		GGSERROR ReadSmfEvent(SmfEvent* smfEvent);

	};

	/// <summary>
	/// SMF̃gbN1Ǘ
	/// </summary>
	class SmfTrack
	{
	private:
		SmfEvent smfEvent;
		SmfStream* smfStream;
		int beginPosition, position, length;

	public:
		// p\
		struct InitParam
		{
			SmfStream* SmfStream;
			int BeginPosition;
			int Length;
		};

		// ݂̈ʒu
		int GetPosition(){ return position; }
		void SetPosition(int pos){ position = pos; }

		// 
		void Initialize(InitParam* initParam);

		// ŏɊ߂
		void Rewind();

		// ݈ʒuf^^C擾
		int ReadDeltaTime(GGSERROR& error);

		// ݈ʒuSMFCxg1{f^^C擾
		SmfEvent* ReadSmfEvent(GGSERROR& error);

	};



	/// <summary>
	/// SMF1ǗNX
	/// </summary>
	class Smf
	{
	private:
		bool isReady, buffered;
		SmfStream* smfStream;
		std::wstring smfFileName;
		int trackCount, timeBase;
		SmfTrack** tracks;
		GgsCode* code;
		VoiceList* voiceList;
		SmfAnalyzedData data;
		STOREDTYPE storedType;

		// wb_[ǂݍ
		GGSERROR ReadHeader();

		// f[^NA
		void ClearData();

	public:
		Smf();	// RXgN^
		~Smf();	// fXgN^

		// ̓f[^IuWFNg
		SmfAnalyzedData* GetData(){ return &data; }

		// GGSCodeR[hIuWFNg
		GgsCode* GetCode(){ return code; }

		// [mۂďɕۑĂǂ
		bool GetBuffered(){ return buffered; }
		void SetBuffered(bool b){ buffered = b; }

		// t@Cۑۑ
		STOREDTYPE GetStoredType(){ return storedType; }

		// t@C
		const wchar_t* GetFileName(){ return smfFileName.c_str(); }

		// f[^̃|C^擾
		const byte* GetBaseAddres(){ return smfStream->GetBaseAddress(); }

		// 
		int GetLength(){ return smfStream->GetLength(); }

		// SMFƂėLǂ
		bool GetIsReady(){ return isReady; }

		// gbN
		int GetTrackCount(){ return trackCount; }

		// ^Cx[X
		int GetTimeBase(){ return timeBase; }

		// t@Cǂݍ
		GGSERROR LoadFromFile(LPCWSTR fileName);

		// ǂݍ
		GGSERROR LoadFromMemory(const byte* smfBinary, int length);

		// SMFoCij
		void ReleaseSmfBinary(){ smfStream->Unload(); }

		// R[hoCij
		void ReleaseCodeBinary(){ code->Clear(); }

		// ēǂݍ
		GGSERROR Reload();

		// gbNIuWFNg擾
		SmfTrack* GetTrack(int index){ return tracks[index]; }

		// ŏ֊߂
		void Rewind();

	};



}}

