// SMFNX

#pragma once

#include "Interface.h"
#include "Analyzer.h"
#include "Compiler.h"

namespace GuruGuruSmf { namespace Core {

	/// <summary>
	/// SMFNX
	/// </summary>
	class SmfController : public ISmfController
	{
	private:
		Smf* smf;
		Analyzer::Analyzer* analyzer;
		Compiler::Compiler* compiler;
		
	public:
		SmfController();			// RXgN^
		virtual ~SmfController();	// fXgN^
		
		//
		// ISmfController
		//

		// SMFIuWFNg擾
		Smf* GetSmf(){ return smf; }
		
		// SMFgp\Ԃɂ
		virtual GGSERROR Open();
		
		// 
		virtual void Close(){ smf->ReleaseCodeBinary(); }
		
		//

		// t@Cǂݍ
		virtual GGSERROR LoadFromFile(LPCWSTR fileName);
		
		// ǂݍ
		virtual GGSERROR LoadFromMemory(const byte* smfBinary, int length);
		
		//

		// 
		void Initialize(Analyzer::Analyzer* analyzerObject, Compiler::Compiler* compilerObject);
		
		//
		
	protected:
		// AnalyzerIuWFNg
		Analyzer::Analyzer* GetAnalyzer(){ return analyzer; }
		
		// CompilerIuWFNg
		Compiler::Compiler* GetCompiler(){ return compiler; }
		
		// ͌ɌĂяo(ʏ͉Ȃ)
		virtual void OnAfterAnalyzed(){}
		
	};

	/// <summary>
	/// SMFNX ver4nEBufferedp
	/// </summary>
	class SmfController4Buffered : public SmfController
	{
	protected:
		// ̎RpCĂ܂
		void OnAfterAnalyzed(){ GetCompiler()->Compile(GetSmf()); }

	public:

		// SMFgp\Ԃɂ(Ȃ)
		GGSERROR Open(){ return GgsError::NoError; }
		
		// (Ȃ)
		void Close(){}

	};
	
	/// <summary>
	/// SMFNX ver4nENot Bufferedp
	/// </summary>
	class SmfController4NotBuffered : public SmfController
	{
	};
	
	/// <summary>
	/// SMFNX ver3nEBufferedp
	/// </summary>
	class SmfController3Buffered : public SmfController
	{
	private:
		byte* smfBuffer;

	public:
		SmfController3Buffered();	// RXgN^
		~SmfController3Buffered();	// fXgN^

		// SMFgp\Ԃɂ
		GGSERROR Open();

		// ǂݍ
		GGSERROR LoadFromMemory(const byte* smfBinary, int length);
	};
	
	/// <summary>
	/// SMFNX ver3nENot Bufferedp
	/// </summary>
	class SmfController3NotBuffered : public SmfController
	{
	};
	


}}


