// Ԋ֌W̃f[^

#pragma once

#include "Constants.h"
#include "Interface.h"
#include "Smf.h"

namespace GuruGuruSmf { namespace Core {
namespace Analyzer {
	
	// Ԋ֌WNX(Analyzer)
	class AnalyzerTimes
	{
	private:
		double timeBaseA, tempoA;
		int markerTick;
		double markerTime;
		
	public:
		// ^Cx[X
		void SetTimeBase(int tb){ timeBaseA = tb * 1000; }
		
		// e|(vTimeBase)
		void SetTempo(double tp){ tempoA = tp / timeBaseA; }
		
		// Tick
		int GetMarkerTick(){ return markerTick; }
		
		// ̉t
		double GetMarkerTime(){ return markerTime; }
		
		// `Ɋ߂
		void Rewind();
		
		// TickTimeXV
		void Update(int tick);
	};
}

namespace WindowsMultimedia
{
	
	// Ԋ֌WNX(WindowsMultimedia.Player)
	class PlayerTimes
	{
	private:
		int timeBase;
		double tempo, tempoA, masterTempo, deltaTick;
		int markerTick, queueTick;
		double nowTime, nowTick, markerTime, queueTime;
		int loopTick, firstNoteTick, lastNoteTick, totalTick;
		double loopTime, firstNoteTime, lastNoteTime, totalTime;
		
	public:
		// RXgN^
		PlayerTimes();
		
		// e|(SMFł̕\l)
		void SetTempo(double tp);
		
		// }X^[e|
		void SetMasterTempo(double mt){ masterTempo = mt; }
		
		// ݂Tick
		int GetNowTick(){ return (int)(nowTick + 0.001); }
		
		// ݂̉t
		int GetNowTime(){ return (int)(nowTime + 0.001); }
		
		// BPM\Lł̃e|l擾
		int GetMusicTempo(){ return (int)(60000000 / tempo + 0.001); }
		
		// MarkerTickȌȂtrue
		bool PassedMarkerTick(){ return nowTick >= markerTick; }
		
		// [vʒuȍ~Ȃtrue
		bool PassedLoopTick(){ return markerTick >= loopTick; }
		
		// ŏ̉ȍ~Ȃtrue
		bool PassedFirstNote(){ return markerTick >= firstNoteTick; }
		
		// Ō̉Ȃtrue
		bool PassedLastNote(){ return markerTick > lastNoteTick; }
		
		// wTickȍ~Ȃtrue
		bool PassedTick(int tick){ return markerTick >= tick; }
		
		// MarkerTickXV
		void UpdateMarkerTick(int delta);
		
		// ݂Ticki߂
		void UpdateNowTick();
		
		// ݂̉tԂC V[NɎgp
		void FixNowTime(int tick);
		
		// ŏ̔̈ʒuֈړ
		void GotoFirstNote();
		
		// [vʒuֈړ
		void GotoLoopPoint(bool isSkipEnding);
		
		// SMFŏ
		void Initialize(Smf* smf);
		
		// `Ɋ߂
		void Rewind();
		
	};

}

namespace DirectMusicPort {

	// Ԋ֌WNX(DirectMusicPort.Player)
	class PlayerTimes : public IDirectMusicTimer
	{
	private:
		bool skipping, realtimeMode;
		int timeBase;
		double tempo, masterTempo;
		__int64 markerDmTime, queueDmTime , nowDmTime, fixedQueueDmTime, pausedDmTime;
		double markerTime, queueTime, nowTime;
		int markerTick, queueTick, nowTick;
		int loopTick, firstNoteTick, lastNoteTick;
		double loopTime, firstNoteTime, lastNoteTime;
		
	public:
		PlayerTimes();	// RXgN^
		
		//
		// IDirectMusicTimer
		//
		
		// ̃bZ[WM\莞
		__int64 GetMarkerDmTime();

		// MԂ1Z(f[^Mp)
		void IncrementMarkerDmTime(){ markerDmTime++; fixedQueueDmTime++; }
		
		//
		
		// e|(SMFł̕\l)
		void SetTempo(double tp){ tempo = tp; }
		
		// }X^[e|
		void SetMasterTempo(double mt){ masterTempo = mt; }
		
		// Tick
		void SetMarkerTick(int mt){ markerTick = mt; }
		
		// ̉t
		void SetMarkerTime(double mt){ markerTime = mt; }
		
		// ݂Tick(vZɂĎZo)
		int GetNowTick(){ return nowTick; }
		
		// ݂̉t(vZɂĎZo)
		double GetNowTime(){ return nowTime; }
		
		// BPM\Lł̃e|l擾
		int GetMusicTempo(){ return (int)(60000000 / tempo + 0.001); }
		
		// DirectMusicԂǂł
		GGSERROR ReadMasterClock();
		
		// ΂鎞true
		void SetSkipping(bool s){ skipping = s; }
		
		// OɉMĂEFCgāAĂȂ΍̎ԂZbg
		void SetMarkerDmTimeByQueueDmTime(__int64 wait);
		
		// MԂɃEFCg
		void Wait(long wait){ markerDmTime += wait; }
		
		// ςݎԂ܂Ŋ߂
		void RewindQueueTime(){ markerDmTime = queueDmTime; }
		
		// [vʒuֈړ
		void GotoLoopPoint();
		
		// XV
		void UpdateMarkerTick(int delta);

		// MԂXV
		void UpdateQueueDmTime();
		
		// ݂̎ԂZo
		void CalcNowTime();
		
		// bZ[WԂ߂Ătrue
		bool PassedPrepareTime(){ return markerDmTime > nowDmTime + Constant::PrepareTime; }
		
		// [vʒuȍ~Ȃtrue
		bool PassedLoopTick(){ return markerTick >= loopTick; }
		
		// ŏ̉ȍ~Ȃtrue
		bool PassedFirstNote(){ return markerTick >= firstNoteTick; }
		
		// Ō̉Ȃtrue
		bool PassedLastNote(){ return markerTick > lastNoteTick; }
		
		// wTickȍ~Ȃtrue
		bool PassedTick(int tick){ return markerTick >= tick; }
		
		// ꎞ~
		void Pause(){ pausedDmTime = nowDmTime; }
		
		// ꎞ~
		void Restart();
		
		// QueueDmTime̕␳
		void FixQueueDmTime(){ fixedQueueDmTime += Constant::TimeInterval * 10000; }
		
		// A^C[hɓ
		void EnterRealtimeMode(){ realtimeMode = true; }
		
		// A^C[h
		void LeaveRealtimeMode(){ realtimeMode = false; }
		
		// SMFŏ
		void Initialize(Smf* smf);
		
		// `Ɋ߂
		void Rewind();
		
		
		
	};


}

}}


