// Windows Multimedia APĨvC[

#pragma once

#include <map>

#include "Interface.h"
#include "Device.h"
#include "Times.h"
#include "Volume.h"
#include "Player.h"

namespace GuruGuruSmf { namespace Core { namespace WindowsMultimedia {

	/// <summary>
	/// WMA[h̃vC[
	/// </summary>
	class Player : public Core::Player::PlayerBase, public IPlayer, public IPlayerCore
	{
	private:
		Device* device;
		int timerId;

		ISmfController* smfController;

		std::map<int, CodeEvent> seekingCodeEventTable;
		bool doMasterPitch;
		
		PlayerTimes* times;
		Volume* volume;
		
		PLAYERSTATE state;
		int loopPosition, loopCount;
		bool isMusicEnd, isPause, doRestart;
		
		bool sentReset;
		__int64 resetedTime;

		// ^C}[Jn
		GGSERROR StartTimer();
		
		// ^C}[~
		void StopTimer();
		
		// ꎞ~
		void WorkerPause();
		
		// ꎞ~
		void WorkerRestart();
		
		// `̋󔒂XLbv
		void SkipBeginning();
		
		// V[N
		void Seek(int tick);
		
		// Zbg߂𑗂
		void SendReset();
		
		// Zbg̃EFCg
		void WaitAfterReset();

	protected:
		// SMFŏ
		void Initialize(Smf* newSmf);
		
		// `Ɋ߂
		void Rewind();

	public:
		Player();	// RXgN^
		~Player();	// fXgN^

		// ^C}[s
		void OnTimer();

		//
		// IPlayer
		//
		
		// foCXJ
		GGSERROR OpenDevice(int deviceId, HWND handle);
		
		// foCX
		void CloseDevice();
		
		// tI
		GGSERROR Play(ISmfController* smfCtrl, int option, int seek, int fadeInTime, int keyShift);
		
		// ~I
		void Stop(int fadeOutTime);
		
		// ꎞ~
		void Pause();
		
		// ꎞ~
		void Restart();
		
		// tԂ擾
		void GetStatus(PlayerStatus* status);
		
		// }X^[e|
		void SetMasterTempo(float masterTempo);
		
		// }X^[{[
		void SetMasterVolume(int masterVolume);
		
		// }X^[sb`
		void SetMasterPitch(int pitch);
		

		//
		// IPlayerCore
		//
		
		// MIDIbZ[WMfoCX擾
		IDevice* GetDevice(){ return device; }
		
		// }[J[TickɉZ
		void AddMarkerTick(int deltaTime);
		
		// I_
		void MusicEnd();
		
		// e|Zbg
		void SetTempo(int newTempo);
		
		// {[bZ[W𑗐M
		void SendVolume(int channel, int vol);
		
		// sb`xhbZ[W𑗐M
		void SendPitchBend(int channel, int pitch);
		
		// GNXN[Vu𑗐M
		void SendExclusive(CodeEvent* codeEvent);
		
		// SeekpɃCxgo^
		void RegisterEvent(CODE_EVENTTYPE type, int channel, int data1, CodeEvent* codeEvent);

		// Vtgꂽm[gԍ擾
		int GetShiftedNote(int note, int channel);
		
	};


}}}


